#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
##################################################
##  admin.cgi - administrative interface        ##
##################################################

package admin;

use lib '.';                                     ## You may need to set this to the full path to cgiworks.pm
use strict;
use cgiworks;

my %map = ( all => \&display_all, main => \&display_main, search => \&display_search );

print "Content-type: text/html\n\n";
$HEADER = 1;

eval {
  require 'arp.pl';
  $srt::filter = 0;
  main();
};

err("$@", 'admin.cgi') if( $@ );
exit;

#####################################################################
##  Removing the link back to CGI Works is a copyright violation.  ##
##  Altering or removing any of the code that is responsible, in   ##
##  any way, for generating that link is strictly forbidden.       ##
##  Anyone violating the above policy will have their license      ##
##  terminated on the spot.  Do not remove that link - ever.       ##
#####################################################################

sub main {
  $TPL{'NFD1'} = $VAR::F1;
  $TPL{'NFD2'} = $VAR::F2;
  $TPL{'NFD3'} = $VAR::F3;
  for( @{ dread("$DDIR/ses", '^[^.]') } ) {
    unlink("$DDIR/ses/$_") || next;
  }
  if( $REQMTH eq 'GET' ) {
    display_login();
  }
  elsif( $REQMTH eq 'POST' ) {
    parsepost();
    derr(1022, "Invalid Password") if( !validpass( freadline("$DDIR/admin.epf"), $FRM{'apwd'} ) );

    $TPL{'APWD'} = $FRM{'apwd'};
    $TPL{'BACK'} = qq|<font face="Verdana" size="2"><b><a href="admin.cgi" class="reg">Back To Main Page</a></b></font>|;
    $TPL{'BACK'} = qq|<input type="hidden" name="fnct" value="display_main"><input type="submit" name="submit" value="Back To Main Page">| if( !$RMTUSR );

    my $call = $FRM{'fnct'};
    derr(1002, "No Function Selected") if( !$call );
    *doit = $call;
    &doit();
  }
}

sub display_login {
  tprint('_admin_login.htmlt');
}

sub display_main {
  $TPL{'MSG'} = shift;
  $TPL{'MRP'} = $VAR::HU . '/' . $VAR::RP;
  $TPL{'PGS'} = getpages();
  $TPL{'BRK'} = getcats();
  $TPL{'SEL'} = arp::getcats();
  $TPL{'AAP'} = $OPT::REV ? dbsize("$DDIR/dbs/review.db") : 'N/A';
  $TPL{'TMB'} = scalar( @{ dread("$DDIR/members", '\.dat') } );
  $TPL{'VER'} = $arp::ver;
  $TPL{'RRF'} = freadline("$DDIR/times/rerank");
  $TPL{'RSF'} = freadline("$DDIR/times/reset");
  $TPL{'LRR'} = timetostr( arp::getage("$DDIR/times/rerank") );
  $TPL{'LRS'} = timetostr( arp::getage("$DDIR/times/reset") );
  $TPL{'LBU'} = timetostr( arp::getage("$DDIR/times/backup") );
  $TPL{'CLR'} = 'Black';

  if( arp::getage("$DDIR/times/backup") > 259200 ) {
    $TPL{'RMD'} = "A database backup is recommended.<br>It has been more than 3 days since your last backup.";
    $TPL{'CLR'} = 'Red';
  }

  fparse('_admin_main.htmlt');
}

sub display_all {
  *sortem = $FRM{'sort'};
  sortem($FRM{'scat'});
  my $size = scalar( @srt::sort );

  $TPL{'SHW'} = $FRM{'show'};
  $TPL{'SHW'} = $size if( $FRM{'show'} eq 'all' );
  $TPL{'STR'} = $FRM{'end'} + 1;
  $TPL{'STR'} = 0 if( $size == 0 );
  $TPL{'END'} = $FRM{'end'} + $FRM{'show'};
  $TPL{'END'} = $size if( $TPL{'END'} > $size || $FRM{'show'} eq 'all' );
  $TPL{'TOT'} = $size;
  $TPL{'NXT'} = $FRM{'show'};
  $TPL{'NXT'} = $size - $TPL{'END'} if( ($size - $TPL{'END'}) < $FRM{'show'} );
  $TPL{'NSL'} = $FRM{'show'} eq 'all' || $TPL{'END'} == $size ? '' : qq|<option value="display_all">Display Next $TPL{'NXT'} Members</option>|;

  $TPL{'MSG'}  = shift;
  $TPL{'MEMS'} = $FRM{'scat'};
  $TPL{'CATS'} = $FRM{'scat'};
  $TPL{'SORT'} = $FRM{'sort'};

  fparse('_admin_allt.htmlt');
  printall($FRM{'scat'}) if( int($TPL{'TOT'}) );
  fparse('_admin_allb.htmlt');
}

sub display_html {
  my $req = $FRM{'hpages'} =~ /\.cgi$/ ? $FRM{'hpages'} : "html/$FRM{'hpages'}";
  require "$DDIR/$req" if( -s "$DDIR/$req" );

  $TPL{'HDR'} = $HTML::HEAD;
  $TPL{'FTR'} = $HTML::FOOT;
  $TPL{'TPL'} = $HTML::TEMP;
  $TPL{'SLC'} = gethtmlsel($FRM{'hpages'});
  fparse('_admin_html.htmlt');
}

sub display_member {
  my $id = (split(/,/, $FRM{'id'}))[0];
  derr(1001, "No Member Selected") if( $id eq '' );
  derr(1015, "Member Not Found") if( !-e "$DDIR/members/$id.dat" );

  $TPL{'FROM'} = $FRM{'from'};
  $TPL{'SORT'} = $FRM{'sort'};
  $TPL{'CATS'} = $FRM{'scat'}; 
  $TPL{'KEY'}  = $FRM{'key'};
  $TPL{'SHW'}  = $FRM{'show'};
  $TPL{'STR'}  = $FRM{'start'};

  memtpl($id);
  fparse('_admin_member.htmlt');
}

sub display_edit {
  my $id = (split(/,/, $FRM{'id'}))[0];
  derr(1001, "No Member Selected") if( $id eq '' );
  derr(1015, "Member Not Found") if( !-e "$DDIR/members/$id.dat" );

  $TPL{'FROM'} = $FRM{'from'};
  $TPL{'SORT'} = $FRM{'sort'};
  $TPL{'CATS'} = $FRM{'scat'}; 
  $TPL{'KEY'}  = $FRM{'key'};
  $TPL{'SHW'}  = $FRM{'show'};
  $TPL{'END'}  = $FRM{'start'} - 1;

  memtpl($id);

  fparse('_admin_edtmem.htmlt');
}

sub display_cheat {
  tprint('_admin_cheat.htmlt');

  open(LOG, "$DDIR/cheat.log") || err($!, 'cheat.log');
  for( <LOG> ) { print }
  close(LOG);

  print qq|</td></tr><tr><td bgcolor="#ffffff" align="center"><input type="submit" name="submit" value="Clear Log">|;
  print qq|<input type="hidden" name="fnct" value="clear_cheat"></td></tr></table></td></tr></table>|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}"></form><br><form action="admin.cgi" method="POST">|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}">$TPL{'BACK'}</form></body></html>|;
}

sub display_error {
  tprint('_admin_error.htmlt');

  open(LOG, "$DDIR/error.log") || err($!, 'error.log');
  for( <LOG> ) { print }
  close(LOG);

  print qq|</td>\n</tr>\n<tr>\n<td bgcolor="#ffffff" align="center">\n<input type="submit" name="submit" value="Clear Log">|;
  print qq|<input type="hidden" name="fnct" value="clear_error">\n</td>\n</tr>\n</table>\n</td>\n</tr>\n</table>\n|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}"></form><br><form action="admin.cgi" method="POST">|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}">$TPL{'BACK'}</form></body></html>|;
}

sub display_breaks {
  my($msg, $htm) = @_;
  $TPL{'MSG'} = $msg;
  $TPL{'PAG'} = $FRM{'bpages'};
  $TPL{'SEL'} = getbreaksel($FRM{'loc'});
  $TPL{'HTM'} = $$htm if( defined $htm );
  fparse('_admin_breaks.htmlt');
}

sub display_bans {
  $TPL{'MSG'} = shift;
  $TPL{'EML'} = ${ freadalls("$DDIR/dbs/email.ban") };
  $TPL{'DOM'} = ${ freadalls("$DDIR/dbs/url.ban") };
  $TPL{'WRD'} = ${ freadalls("$DDIR/dbs/word.ban") };
  fparse('_admin_bans.htmlt');
}

sub display_reject {
  my($msg, $htm) = @_;
  $TPL{'MSG'} = $msg;
  $TPL{'HTM'} = $$htm if( defined $htm );
  $TPL{'RID'} = $FRM{'id'};
  fparse('_admin_reject.htmlt');
  printreject();
}

sub display_chpass {
  fparse('_admin_chpass.htmlt');
}

sub display_backup {
  fparse('_admin_backup.htmlt');
}

sub display_icons {
  my($msg, $htm) = @_;
  $TPL{'MSG'} = $msg;
  $TPL{'HTM'} = $$htm if( defined $htm );
  $TPL{'IID'} = $FRM{'id'};
  fparse('_admin_iconst.htmlt');
  printicons();
  fparse('_admin_iconsb.htmlt');
}

sub display_gate {
  $TPL{'URL'} = '#%URL%#';
  $TPL{'DDIR'} = $DDIR;
  fparse('_admin_gate.htmlt');
}

sub display_search {
  derr(1001, "No Search Term Entered") if( $FRM{'key'} eq '' );
  $TPL{'KEY'} = $FRM{'key'};
  fparse('_admin_searcht.htmlt');
  printsearch($FRM{'key'});
  fparse('_admin_searchb.htmlt');
}

sub display_stats {
  for( @{ dread("$DDIR/members", '\.cnt$') } ) {
    my $cd = fsplit("$DDIR/members/$_");
    $TPL{'HIN'}  += $cd->[0];
    $TPL{'HOUT'} += $cd->[1];
    $TPL{'TIN'}  += $cd->[2];
    $TPL{'TOUT'} += $cd->[3];
  }
  my $time = freadline("$DDIR/dbs/start");
  my $age = time + ($VAR::TZ * 3600) - $time;
  $TPL{'START'} = fdate($VAR::DF, $time) . ' ' . ftime($VAR::TF, $time);
  $TPL{'IPDAY'} = arp::getavg($TPL{'TIN'}, $age, 86400);
  $TPL{'IPWEK'} = arp::getavg($TPL{'TIN'}, $age, 604800);
  $TPL{'IPMTH'} = arp::getavg($TPL{'TIN'}, $age, 2592000);
  $TPL{'OPDAY'} = arp::getavg($TPL{'TOUT'}, $age, 86400);
  $TPL{'OPWEK'} = arp::getavg($TPL{'TOUT'}, $age, 604800);
  $TPL{'OPMTH'} = arp::getavg($TPL{'TOUT'}, $age, 2592000);

  fparse('_admin_statst.htmlt');
  printstats();
  fparse('_admin_statsb.htmlt');
}

sub display_rev {
  derr(1018, "Not Reviewing New Accounts") if( !$OPT::REV );
  
  $TPL{'MSG'} = shift;

  fparse('_admin_revt.htmlt');
  printrev();
  fparse('_admin_revb.htmlt');
}

sub display_edtrev {
  derr(1001, "No Account Selected") if( !$FRM{'id'} );
  my $id = (split(/,/, $FRM{'id'}))[0];
  my $md = dbselect("$DDIR/dbs/review.db", $id, '\|');

  $TPL{'USER'} = $id;
  $TPL{'PASS'} = unpack('u', $md->[20]);
  $TPL{'SURL'} = $md->[2];
  $TPL{'TITL'} = $md->[7];
  $TPL{'DESC'} = $md->[8];
  $TPL{'RURL'} = $md->[6];
  $TPL{'BURL'} = $md->[3];
  $TPL{'BWD'}  = $md->[4];
  $TPL{'BHT'}  = $md->[5];
  $TPL{'SCAT'} = arp::getcats($md->[9]);
  $TPL{'MAIL'} = $md->[1];
  $TPL{'FLD1'} = $md->[24];
  $TPL{'FLD2'} = $md->[25];
  $TPL{'FLD3'} = $md->[26];

  fparse('_admin_edtrev.htmlt');
}

sub display_list {
  fparse('_admin_lsteml.htmlt');
}

sub display_emails {
  my %key = (newline => "\n", tab => "\t", space => " ");
  my $del = $key{$FRM{'ch'}} ? $key{$FRM{'ch'}} : $FRM{'ch'};

  print "<pre>\n" if( !$FRM{'file'} );
  fwrite("$DDIR/emails.txt", '') if( $FRM{'file'} );
  for( @{ dread("$DDIR/members", '\.dat$') } ) {
    if( $FRM{'file'} ) {
      fappend("$DDIR/emails.txt", @{ fsplit("$DDIR/members/$_") }[0] . $del);
    } else {
      print @{ fsplit("$DDIR/members/$_") }[0] . $del;
    }
  }

  display_main("E-mails written to emails.txt in the data directory") if( $FRM{'file'} );
}

sub display_mail {
  $FRM{'id'} = 'All' if( $FRM{'from'} eq 'main' && $FRM{'fnct'} ne 'remove' && !$FRM{'check'} );
  derr(1020, "No Members To Mail") if( $FRM{'id'} eq '' );

  $FRM{'id'}   =~ s/,$//;
  $TPL{'TO'}   = $TPL{'SEND'} = $FRM{'id'};
  $TPL{'SEND'} =~ s/,/, /g;
  $TPL{'FROM'} = $FRM{'from'};
  $TPL{'SORT'} = $FRM{'sort'};
  $TPL{'CATS'} = $FRM{'scat'}; 
  $TPL{'KEY'}  = $FRM{'key'};
  $TPL{'SHW'}  = $FRM{'show'};
  $TPL{'END'}  = $FRM{'start'} - 1;

  fparse('_admin_mail.htmlt');
}

##############################################################################
##############################################################################

sub send_mail {
  derr(1001, "Subject Left Blank") if( $FRM{'sub'} eq '' );
  derr(1001, "Message Left Blank") if( $FRM{'msg'} eq '' );
  $FRM{'to'} eq 'All' ? forkmail() : regmail();
}

sub forkmail {
  my $pid = fork();

  if( !$pid ) {
    for( @{ dread("$DDIR/members", '\.dat$') } ) {
      my $id  = arp::getmem($_);
      memtpl($id);
      my $msg = qq|To: $TPL{'MAIL'}\nFrom: $VAR::EM\nSubject: $FRM{'sub'}\n\n|;
      $msg .= $FRM{'msg'};
      mail($VAR::ES, \$msg, \%TPL);
    }
    sleep(1);
  }
  else {
    display_main("Accounts Have Been E-mailed");
    print '<font color="#ffffff">';
  }
}

sub regmail {
  for( split(/,/, $FRM{'to'}) ) {
    memtpl($_);
    my $msg = qq|To: $TPL{'MAIL'}\nFrom: $VAR::EM\nSubject: $FRM{'sub'}\n\n|;
    $msg .= $FRM{'msg'};
    mail($VAR::ES, \$msg, \%TPL);
  }
  &{ $map{$FRM{'from'}} }("Accounts Have Been E-mailed");
}

sub approve {
  for( split(/,/, $FRM{'id'}) ) {
    my $md = dbselect("$DDIR/dbs/review.db", $_, '\|');
    next if( !$md );
    shift @{ $md };

    fjoin("$DDIR/members/$_.dat", @{ $md });
    fjoin("$DDIR/members/$_.cnt",  0, 0, 0, 0, $md->[11], $md->[12], $md->[8], 0, $md->[10]);
    fappend("$DDIR/dbs/sites", $_ . "\n");
    fappend("$DDIR/dbs/search", "$_|$md->[6]|$md->[8]|$md->[1]|$md->[7]\n");
    fcreate("$DDIR/members/$_.sts");

    dbdelete("$DDIR/dbs/review.db", $_, '\|');

    $TPL{'FROM'} = $VAR::EM;
    $TPL{'TO'}   = $md->[0];
    $TPL{'TURL'} = $VAR::IU . "?id=$_";
    $TPL{'LURL'} = $VAR::CU . "/accounts.cgi?login";

    memtpl($_);
    mail($VAR::ES, freadalls("$TDIR/_email_approved.etmpl"), \%TPL) if( $OPT::EML );
  }
  $FRM{'id'} =~ s/,/, /g;
  display_rev("Accounts $FRM{'id'} Have Been Approved");
}

sub reject {
  for( split(/,/, $FRM{'id'}) ) {
    my $md = dbselect("$DDIR/dbs/review.db", $_, '\|');
    next if( !$md );
    dbdelete("$DDIR/dbs/review.db", $_, '\|');

    $TPL{'FROM'} = $VAR::EM;
    $TPL{'TO'}   = $md->[1];
    $TPL{'USER'} = $_;
    $TPL{'SURL'} = $md->[2];
    $TPL{'TITL'} = $md->[7];
    $TPL{'DESC'} = $md->[8];
    $TPL{'CAT'}  = $md->[9];

    my $rej = "rej_$_";
    mail($VAR::ES, freadalls("$DDIR/mails/$FRM{$rej}"), \%TPL) if( $FRM{$rej} ne 'none' );
  }
  $FRM{'id'} =~ s/,/, /g;
  display_rev("Accounts $FRM{'id'} Have Been Rejected");
}

sub remove {
  derr(1019, "Invalid Data") if( $FRM{'inact'} !~ /^\d+$/ || $FRM{'inact'} < 1);
  my $count = 0;

  for( @{ dread("$DDIR/members", '\.dat$') } ) {
    my $md = fsplit("$DDIR/members/$_");

    if( $md->[22] >= $FRM{'inact'} ) {
      my $id = arp::getmem($_);

      if( $FRM{'what'} eq 'mail' ) {
        $FRM{'id'} .= "$id,";
      } else {
        $count++;
        fremove("$DDIR/members/$id.cnt");
        fremove("$DDIR/members/$id.dat");
        fremove("$DDIR/members/$id.sts");
        dbdelete("$DDIR/dbs/sites", $id, '\n');
        dbdelete("$DDIR/dbs/search", $id, '\|');
      }
    }
  }

  $FRM{'what'} eq 'mail' ? display_mail() : display_main("$count Inactive Accounts Have Been Removed");
}

sub updaterev {
  my $id = $FRM{'id'};
  my $md = dbselect("$DDIR/dbs/review.db", $id, '\|');

  $md->[1] = $FRM{'mail'};
  $md->[2] = $FRM{'surl'};
  $md->[3] = $FRM{'burl'};
  $md->[4] = $FRM{'bht'};
  $md->[5] = $FRM{'bwd'};
  $md->[6] = $FRM{'rurl'};
  $md->[7] = $FRM{'titl'};
  $md->[8] = $FRM{'desc'};
  $md->[9] = $FRM{'cat'};
  $md->[19] = crypt($FRM{'pass'}, getsalt());
  $md->[20] = pack('u', $FRM{'pass'});
  chomp($md->[20]);
  $md->[24] = $FRM{'fld1'};
  $md->[25] = $FRM{'fld2'};
  $md->[26] = $FRM{'fld3'};

  dbupdate("$DDIR/dbs/review.db", $id, '\|', @{ $md });

  display_rev("Account '$id' Has Been Updated");
}

sub lock {
  adjust("$FRM{'id'}.dat", 21, 1);
  $FRM{'start'}--;
  &{ $map{$FRM{'from'}} }("Account '$FRM{'id'}' Has Been Locked");
}

sub unlock {
  adjust("$FRM{'id'}.dat", 21, 0);
  $FRM{'start'}--;
  &{ $map{$FRM{'from'}} }("Account '$FRM{'id'}' Has Been Unlocked");
}

sub suspend {
  adjust("$FRM{'id'}.dat", 20, 1);
  adjust("$FRM{'id'}.cnt", 7, 1);
  dbdelete("$DDIR/dbs/search", $FRM{'id'}, '\|');
  dbdelete("$DDIR/dbs/sites", $FRM{'id'}, '\n');
  $FRM{'start'}--;
  &{ $map{$FRM{'from'}} }("Account '$FRM{'id'}' Has Been Suspended");
}

sub activate {
  adjust("$FRM{'id'}.dat", 20, 0);
  adjust("$FRM{'id'}.cnt", 7, 0);

  my $md = fsplit("$DDIR/members/$FRM{'id'}.dat");
  fappend("$DDIR/dbs/search", "$FRM{'id'}|$md->[6]|$md->[8]|$md->[1]|$md->[7]\n");
  fappend("$DDIR/dbs/sites", "$FRM{'id'}\n");
  $FRM{'start'}--;
  &{ $map{$FRM{'from'}} }("Account '$FRM{'id'}' Has Been Reactivated");
}

sub delete_member {
  derr(1001, "No Member Selected") if( $FRM{'id'} eq '' );
  for( split(/,/, $FRM{'id'}) ) {
    fremove("$DDIR/members/$_.dat");
    fremove("$DDIR/members/$_.cnt");
    fremove("$DDIR/members/$_.sts");
    dbdelete("$DDIR/dbs/sites", $_, '\n');
    dbdelete("$DDIR/dbs/search", $_, '\|');
  }
  $FRM{'end'} = $FRM{'start'} - 1;
  &{ $map{$FRM{'from'}} }("Account(s) $FRM{'id'} Have Been Deleted");
}

sub create_gate {
  $FRM{'html'} =~ s/\r//g;
  $FRM{'html'} =~ s/\@/\\\@/g;
  $FRM{'html'} =~ s/\$/\\\$/g;
  $FRM{'html'} =~ s/#%URL%#/\$VAR::IU\?id=\$id&ses=\$ses/gi;
  $TPL{'PERL'} = $FRM{'perl'};
  $TPL{'DDIR'} = $FRM{'ddir'};
  $TPL{'HTML'} = $FRM{'html'};

  open(CGI, ">$DDIR/rankem.cgi") || err($!, "$DDIR/rankem.cgi");
  fparse('_rankem.cgit', \*CGI);
  close(CGI);
  mode(0666, "$DDIR/rankem.cgi");

  display_main("Custom Version of rankem.cgi Has Been Created");
}

sub reset_list {
  arp::resetlist();
  fwrite("$DDIR/times/reset", 'Manual');
  display_main("List Has Been Reset");
}

sub rerank_list {
  $srt::filter = 1;
  arp::rerank(1);
  fwrite("$DDIR/times/rerank", 'Manual');
  $TPL{'APWD'} = $FRM{'apwd'};
  display_main("List Has Been Reranked");
}

sub execute {
  my $call = $FRM{'function'};
  *doit = $call;
  derr(1012, "No Function Selected") if( !$call );
  &doit();
}

sub backup_data {
  derr(1001, "You must enter a filename") if( $FRM{'file'} eq '' );
  my @dirs = qw( html icons breaks dbs members mails ); my $dir;
  fwrite("$DDIR/$FRM{'file'}");

  foreach $dir ( @dirs ) { 
    for( @{ dread("$DDIR/$dir", '^[^.]') } ) {
      fappend("$DDIR/$FRM{'file'}", "Database: $dir/$_\n");
      open(DB, "$DDIR/$dir/$_") || err($!, "$DDIR/$dir/$_");
      while( <DB> ) {
        fappend("$DDIR/$FRM{'file'}", $_);
      }
      close(DB);
      fappend("$DDIR/$FRM{'file'}", "\n") if( $dir eq 'members' );
    }
  }

  fwrite("$DDIR/times/backup", time);
  display_main("Databases Have Been Backed Up To $FRM{'file'}");
}

sub restore_data {
  derr(1001, "You must enter a filename") if( $FRM{'file'} eq '' );
  my $file;

  open(BAK, "$DDIR/$FRM{'file'}") || err($!, "$DDIR/$FRM{'file'}");
  while( <BAK> ) {
    if( $_ =~ /Database: (.*)\n/ ) {
      $file = $1;
      fwrite("$DDIR/$file");
      next;
    }
    chomp( $_ ) if( $file =~ /members\// );
    fappend("$DDIR/$file", $_);
  }
  close(BAK);

  for( @{ dread("$DDIR/members", '\.dat') } ) {
    my $md = fsplit("$DDIR/members/$_");
    $md->[18] = crypt(unpack('u', $md->[19]), getsalt());
    fjoin("$DDIR/members/$_", @{ $md });
  }

  display_main("Databases Have Been Restored");
}

##  Edit Blacklist Functions
sub add_ban {
  $FRM{'ban'} =~ s/\r//g;
  derr(1023, "No Blank Lines Allowed") if( $FRM{'ban'} eq '' || $FRM{'ban'} =~ /^\n/m );
  fappend("$DDIR/dbs/$FRM{'type'}.ban", "$FRM{'ban'}\n");
  display_bans("$FRM{'ban'} Added To the $FRM{'type'} Blacklist");
}

sub rem_ban {
  $FRM{'ban'} =~ s/\r//g;

  for( split(/\n/, $FRM{'ban'}) ) {
    dbdelete("$DDIR/dbs/$FRM{'type'}.ban", $_, '\n');
  }
  display_bans("$FRM{'ban'} Removed From the $FRM{'type'} Blacklist");
}

##  Edit icon functions 
sub delete_icon {
  derr(1001, "Bad Icon ID Entered") if( !-e "$DDIR/icons/$FRM{'id'}" || $FRM{'id'} eq "" );
  fremove("$DDIR/icons/$FRM{'id'}");
  my $id = $FRM{'id'};
  delete $FRM{'id'};
  display_icons("Icon '$id' Has Been Deleted");
}

sub load_icon {
  derr(1001, "Bad Icon ID Entered") if( !-e "$DDIR/icons/$FRM{'id'}" || $FRM{'id'} eq "");
  display_icons("Loaded Icon With ID '$FRM{'id'}'", freadalls("$DDIR/icons/$FRM{'id'}"));
}

sub save_icon {
  derr(1001, "No Icon ID Entered") if( $FRM{'id'} eq '' );
  $FRM{'id'} =~ s/ /_/g;
  $FRM{'html'} =~ s/\r//g;
  fwrite("$DDIR/icons/$FRM{'id'}", $FRM{'html'} . "\n");
  my $id = $FRM{'id'};
  delete $FRM{'id'};
  display_icons("Saved Icon With ID '$id'");
}

##  Edit Rejection e-mail functions 
sub del_reject {
  derr(1026, "Bad E-mail ID Entered") if( !-e "$DDIR/mails/$FRM{'id'}" || $FRM{'id'} eq "" );
  fremove("$DDIR/mails/$FRM{'id'}");
  my $id = $FRM{'id'};
  delete $FRM{'id'};
  display_reject("Rejection E-mail '$id' Has Been Deleted");
}

sub load_reject {
  derr(1026, "Bad E-mail ID Entered") if( !-e "$DDIR/mails/$FRM{'id'}" || $FRM{'id'} eq "");
  display_reject("Loaded Rejection E-mail With ID '$FRM{'id'}'", freadalls("$DDIR/mails/$FRM{'id'}"));
}

sub save_reject {
  derr(1026, "No E-mail ID Entered") if( $FRM{'id'} eq "" );
  $FRM{'id'} =~ s/ /_/g;
  $FRM{'html'} =~ s/\r//g;
  fwrite("$DDIR/mails/$FRM{'id'}", $FRM{'html'} . "\n");
  my $id = $FRM{'id'};
  delete $FRM{'id'};
  display_reject("Saved Rejection E-mail With ID '$id'");
}

## Edit list break functions
sub load_break {
  my $fln = arp::htmlname($FRM{'bpages'}) . '.' . $VAR::FE;
  $fln = $VAR::RP if( $FRM{'bpages'} eq 'Overall' );
  my $htm = freadalls("$DDIR/breaks/$FRM{'loc'}.$fln") if( -e "$DDIR/breaks/$FRM{'loc'}.$fln");
  display_breaks("Loaded HTML for position $FRM{'loc'} in $FRM{'bpages'}", $htm);
}

sub save_break {
  my $brk = $FRM{'loc'};
  my $for = "Position $FRM{'loc'}";
  my $fln = arp::htmlname($FRM{'bpages'}) . '.' . $VAR::FE;
  $fln = $VAR::RP if( $FRM{'bpages'} eq 'Overall' );
  $FRM{'html'} =~ s/\r//g;

  if( $FRM{'all'} ) {
    $brk = $VAR::BO;
    $for = "All Breaks";
  }

  for( split(/,/, $brk) ) {
    fwrite("$DDIR/breaks/$_.$fln", $FRM{'html'} . "\n");
  }
  display_breaks("HTML Saved For $for in $FRM{'bpages'}");
}

sub restore_def {
  my $def = freadalls("$DDIR/def.html");
  for( split(/,/, $VAR::PO) ) {
    fwrite("$DDIR/html/$_", $$def );
  }

  for( split(/,/, $VAR::PC) ) {
    fwrite("$DDIR/html/$_", $$def );
  }

  display_main("Default Template Has Been Restored");
}

sub clear_memstats {
  for( @{ dread("$DDIR/members", '\.sts$') } ) {
    open(TMP, ">$DDIR/members/$_");
    close(TMP);
  }
  display_main("Member Stats Files Have Been Cleared");
}

sub clear_admstats {
  open(TMP, ">$DDIR/stats");
  close(TMP);
  display_main("Administrative Stats Have Been Cleared")
}

sub clear_ips {
  for( 1..255 ) {
    open(FILE, ">$DDIR/ips/$_") || err($!, "$DDIR/ips/$_");
    close(FILE);
  }
  display_main("IP Logs Have Been Cleared");
}

sub clear_cheat {
  fwrite("$DDIR/cheat.log");
  display_main("Cheat Log Has Been Cleared");
}

sub clear_error {
  fwrite("$DDIR/error.log");
  display_main("Error Log Has Been Cleared");
}

sub update_pass {
  derr(1001, "You Must Enter A Username") if( $FRM{'un'} eq '' );
  derr(1001, "You Must Enter A Password") if( $FRM{'pw'} eq '' );

  fwrite('.htpasswd', "$FRM{'un'}:" . crypt($FRM{'pw'}, getsalt())) if( $RMTUSR );
  fwrite("$DDIR/admin.epf", crypt($FRM{'pw'}, getsalt()));
  $TPL{'APWD'} = $FRM{'pw'};

  display_main('Administrative Username/Password Has Been Updated');
}

sub update_account {
  my $id = $FRM{'id'};
  my $cd = fsplit("$DDIR/members/$id.cnt");
  my $md = fsplit("$DDIR/members/$id.dat");

  for( keys %FRM ) {
    $FRM{$_} =~ s/</&lt;/g;
    $FRM{$_} =~ s/>/&gt;/g;
  }

  $md->[0]  = $FRM{'mail'};
  $md->[1]  = $FRM{'surl'};
  $md->[2]  = $FRM{'burl'};
  $md->[3]  = $FRM{'bht'};
  $md->[4]  = $FRM{'bwd'};
  $md->[5]  = $FRM{'rurl'};
  $md->[6]  = $FRM{'titl'};
  $md->[7]  = $FRM{'desc'};
  $cd->[6]  = $md->[8] = $FRM{'cat'};
  $md->[18] = crypt($FRM{'pass'}, getsalt());
  $md->[19] = pack('u', $FRM{'pass'});
  chomp($md->[19]);
  $md->[9]  = $FRM{'icon'};
  $cd->[7]  = $md->[20] = $FRM{'susp'};
  $md->[21] = $FRM{'lock'};
  $md->[22] = $FRM{'inac'};
  $cd->[4]  = $md->[11] = $FRM{'rat'};
  $cd->[5]  = $md->[12] = sprintf("%.3f", (split(/:/, $FRM{'rat'}))[0] / (split(/:/, $FRM{'rat'}))[1] );
  $md->[23] = $FRM{'fld1'};
  $md->[24] = $FRM{'fld2'};
  $md->[25] = $FRM{'fld3'};

  $cd->[0]  = $FRM{'rhin'};
  $cd->[1]  = $FRM{'hout'};
  $cd->[2]  = $FRM{'rtin'};
  $cd->[3]  = $FRM{'tout'};

  fjoin("$DDIR/members/$id.cnt", @{ $cd });
  fjoin("$DDIR/members/$id.dat", @{ $md });
  dbupdate("$DDIR/dbs/search", $id, '\|', $id, $md->[6], $md->[8], $md->[1], $md->[7]);

  &{ $map{$FRM{'from'}} }("Account '$id' Has Been Updated");
}

sub update_html {
  $FRM{'head'} =~ s/\r|\n$//g;
  $FRM{'foot'} =~ s/\r|\n$//g;
  $FRM{'temp'} =~ s/\r|\n$//g;
  
  my $dir = '';
  $dir = 'html/' if( $FRM{'pages'} !~ /\.cgi$/ );

  for( split(/,/, $FRM{'pages'}) ) {
    fwrite("$DDIR/$dir$_", qq|\$HTML::HEAD = <<'HD';\n$FRM{'head'}\nHD\n\n\$HTML::FOOT = <<'FT';\n$FRM{'foot'}\nFT\n\n\$HTML::TEMP = <<'TP';\n$FRM{'temp'}\nTP\n\n1;\n|);
  }

  display_main("HTML Successfully Updated");
}

sub printreject {
  for( @{ dread("$DDIR/mails", '^[^.]') } ) {
    my $id = $_;
    my $htm = freadalls("$DDIR/mails/$id");
    print qq|<tr bgcolor="#ffffff">\n<td>\n<font face="Verdana" size="2">\n<b>E-mail ID:</b> $id\n</font>\n<br>\n<pre>$$htm</pre>\n</td>\n</tr>\n|;
  }
  print qq|</table>\n</td>\n</tr>\n</table>\n\n|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}"></form><br><form action="admin.cgi" method="POST">|;
  print qq|<input type="hidden" name="apwd" value="$TPL{'APWD'}">$TPL{'BACK'}</form></body></html>|;
}

sub printicons {
  for( @{ dread("$DDIR/icons", '^[^.]') } ) {
    my $id = $_;
    my $htm = freadalls("$DDIR/icons/$id");
    print qq|<tr bgcolor="#ffffff">\n<td>\n<font face="Verdana" size="2">\n<b>Icon ID:</b> $id\n</font>\n<br>\n$$htm\n</td>\n</tr>\n|;
  }
}

sub geticons {
  my @in = split(/,/, shift);
  chomp(@in);
  my %icons; @icons{@in} = (1..scalar( @in ));
  my $html;

  for( @{ dread("$DDIR/icons", '^[^.]') } ) {
    $html .= qq|<input type="checkbox" name="icon" value="$_"|;
    $html .= $icons{$_} ? 'checked' : ''; 
    $html .= qq|> | . ${ freadalls("$DDIR/icons/$_") } . qq|<br>|;
  }
  return \$html;
}

sub gethtmlsel {
  my $temp = shift;
  my $html = qq|<option value="$temp">$temp Only</option>|;
  if( $temp !~ /\.cgi$/ ) {
    $html   .= qq|<option value="$VAR::PO">All Overall Pages</option>|;
    $html   .= qq|<option value="$VAR::PC">All Category Pages</option>| if( $OPT::GSP );
    $html   .= qq|<option value="$VAR::PO,$VAR::PC">All Pages</option>| if( $OPT::GSP );
  }
  return $html;
}

sub getpages {
  my $html = '';
  for( split(/,/, $VAR::PO) ) { $html .= qq|<option value="$_">$_</option>|; }

  if( $OPT::GSP ) {
    for( split(/,/, $VAR::PC) ) { $html .= qq|<option value="$_">$_</option>|; }
  }

  return $html;
}

sub getbreaksel {
  my $html   = qq|<option value="$_[0]">$_[0]</option>| if( $_[0] );
  for( split(/,/, $VAR::BO) ) {
    $html .= qq|<option value="$_">$_</option>\n|;
  }
  return $html;
}

sub printall {
  my $i;
  for( $i = $TPL{'STR'} - 1; $i <= $TPL{'END'} - 1; $i++ ) {
    memtpl(arp::getmem($srt::sort[$i]));
    $TPL{'SVAL'} = (split(/\|/, $srt::mem{$srt::sort[$i]}))[0];
    $TPL{'SVAL'} = $TPL{'DATE'} if( $FRM{'sort'} eq 'srt::bydate' );
    $TPL{'BURL'} = $TPL{'BURL'} eq '' ? 'None' : qq|<a href="javascript:openBanner('$TPL{'BURL'}');" class="reg">Click Here</a>|;
    fparse('_admin_allm.htmlt');
  }
}

sub printsearch {
  my $key = shift;
  for( @{ dread("$DDIR/members", '\.dat$') } ) {
    my $md = freadline("$DDIR/members/$_");
    next if( $md !~ /$key/i );
    memtpl(arp::getmem($_));
    $TPL{'BURL'} = $TPL{'BURL'} eq '' ? 'None' : qq|<a href="javascript:openBanner('$TPL{'BURL'}');" class="reg">Click Here</a>|;
    fparse('_admin_searchm.htmlt');
  }
}

sub printstats {
  open(FILE, "$DDIR/stats") || err($!, 'stats');
  for( reverse <FILE> ) {
    my @stats = split(/\|/, $_);
    $TPL{'DATE'} = $stats[0];
    $TPL{'IN'}   = $stats[1];
    $TPL{'OUT'}  = $stats[2];
    $TPL{'ACT'}  = $stats[5];
    $TPL{'TOP'}  = arp::getmem($stats[6]);
    fparse('_admin_statsm.htmlt');
  }
  close(FILE);
}

sub printrev {
  for( @{ dread("$DDIR/mails", '^[^.]') } ) {
    $TPL{'REJ'} .= qq|<option value="$_">$_</option>\n|;
  }

  open(REV, "$DDIR/dbs/review.db") || err($!, 'review.db');
  while( <REV> ) {
    my @md = split(/\|/, $_);

    $TPL{'USER'} = $md[0];
    $TPL{'CAT'}  = $md[9];
    $TPL{'SURL'} = $md[2];
    $TPL{'BURL'} = $md[3] eq '' ? 'None' : qq|<a href="javascript:openBanner('$md[3]');" class="reg">Click Here</a>|;
    $TPL{'TITL'} = $md[7];
    $TPL{'DESC'} = $md[8];
    $TPL{'RURL'} = $md[6] eq '' ? 'None' : qq|<a href="$md[6]" target="_new" class="reg">Click Here</a>|;;
    $TPL{'MAIL'} = $md[1];
    $TPL{'SEL'}  = "rej_$md[0]";
    $TPL{'FLD1'} = $md[24];
    $TPL{'FLD2'} = $md[25];
    $TPL{'FLD3'} = $md[26];
    fparse('_admin_revm.htmlt');
  }
  close(REV);
}

sub memtpl {
  my $id = shift;
  my $cd  = fsplit("$DDIR/members/$id.cnt");
  my $md  = fsplit("$DDIR/members/$id.dat");
  my $age = time - $md->[10];

  $TPL{'USER'} = $id;
  $TPL{'PASS'} = unpack('u', $md->[19]);
  $TPL{'EMAL'} = $TPL{'MAIL'} = $md->[0];
  $TPL{'SURL'} = $md->[1];
  $TPL{'BURL'} = $md->[2];
  $TPL{'BHT'}  = $md->[3];
  $TPL{'BWD'}  = $md->[4];
  $TPL{'RURL'} = $md->[5];
  $TPL{'TITL'} = $md->[6];
  $TPL{'DESC'} = $md->[7];
  $TPL{'INAC'} = $md->[22];
  $TPL{'LOCK'} = int($md->[21]) ? '<font color="red">Locked</font>' : 'Not Locked';
  $TPL{'SUSP'} = int($md->[20]) ? '<font color="red">Suspended</font>' : 'Active';
  $TPL{'LOPT'} = int($md->[21]) ? qq|<option value="unlock">Unlock Account</option>| : qq|<option value="lock">Lock Account</option>|;
  $TPL{'SOPT'} = int($md->[20]) ? qq|<option value="activate">Activate Account</option>| : qq|<option value="suspend">Suspend Account</option>|;
  $TPL{'SYN'}  = getyesno($md->[20]);
  $TPL{'LYN'}  = getyesno($md->[21]);
  $TPL{'ICON'} = arp::geticons($md->[9]);
  $TPL{'SICO'} = ${ geticos($md->[9]) };
  $TPL{'CAT'}  = $md->[8];
  $TPL{'SCAT'} = arp::getcats($md->[8]);
  $TPL{'DATE'} = fdate($VAR::DF, $md->[10] + ($VAR::TZ * 3600)) . ' ' . ftime($VAR::TF, $md->[10] + ($VAR::TZ * 3600));
  $TPL{'RAT'}  = $md->[11];
  $TPL{'HIN'}  = int($cd->[0] * $cd->[5]);
  $TPL{'RHIN'} = $cd->[0];
  $TPL{'HOUT'} = $cd->[1];
  $TPL{'TIN'}  = int($cd->[2] * $cd->[5]);
  $TPL{'RTIN'} = $cd->[2];
  $TPL{'TOUT'} = $cd->[3];
  $TPL{'IPDY'} = arp::getavg($TPL{'TIN'}, $age, 86400);
  $TPL{'IPWK'} = arp::getavg($TPL{'TIN'}, $age, 604800);
  $TPL{'IPMT'} = arp::getavg($TPL{'TIN'}, $age, 2592000);
  $TPL{'OPDY'} = arp::getavg($TPL{'TOUT'}, $age, 86400);
  $TPL{'OPWK'} = arp::getavg($TPL{'TOUT'}, $age, 604800);
  $TPL{'OPMT'} = arp::getavg($TPL{'TOUT'}, $age, 2592000);
  $TPL{'FLD1'} = $md->[23];
  $TPL{'FLD2'} = $md->[24];
  $TPL{'FLD3'} = $md->[25];
}

sub getcats {
  my $html = '';
  if( $OPT::GSP ) {
    for( split(/,/, $VAR::CT) ) {
      $html .= qq|<option value="$_">$_</option>|;
    }
  }
  return $html;
}

sub geticos {
  my @in = split(/,/, shift);
  chomp(@in);
  my %icons; @icons{@in} = (1..scalar( @in ));
  my $html;

  for( @{ dread("$DDIR/icons", '^[^.]') } ) {
    $html .= qq|<input type="checkbox" name="icon" value="$_"|;
    $html .= $icons{$_} ? 'checked' : ''; 
    $html .= qq|> | . ${ freadalls("$DDIR/icons/$_") } . qq|<br>|;
  }
  return \$html;
}

sub getyesno {
  my($in, $html) = shift;
  $html = qq|<option value="0"|;
  $html .= qq| selected| if( $in eq '0' );
  $html .= qq|>No</option><option value="1"|;
  $html .= qq| selected| if( $in eq '1' );
  $html .= qq|>Yes</option>|;
}

sub adjust {
  my( $id, $key, $val ) = @_;
  my $md = fsplit("$DDIR/members/$id");
  $md->[$key] = $val;
  fjoin("$DDIR/members/$id", @{ $md });
}