#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
##################################################
##  index.cgi - display the quick list          ##
##################################################

package idx;

use strict;
#push(@INC, 'c:/full/path/to/cgi/scripts');       ## NT support - uncomment and fill in correct path if necessary.

my $DDIR = './data';
my %TPL;

print "Content-type: text/html\n\n";

eval {
  require "$DDIR/vars.dat";
  require "$DDIR/index.cgi";
  main();
};

err("$@", 'index.cgi') if( $@ );
exit;

#####################################################################
##  Removing the link back to CGI Works is a copyright violation.  ##
##  Altering or removing any of the code that is responsible, in   ##
##  any way, for generating that link is strictly forbidden.       ##
##  Anyone violating the above policy will have their license      ##
##  terminated on the spot.  Do not remove that link - ever.       ##
#####################################################################

sub main {
  print $HTML::HEAD;

  open(DATA, "$DDIR/dbs/search") || err($!, '$DDIR/dbs/search');
  while( <DATA> ) {
    my @md = split(/\|/, $_);

    $TPL{'TITLE'} = $md[1];
    $TPL{'URL'}   = $OPT::OUT ? "$VAR::OU?id=$md[0]&url=" . urlencode($md[3]) : $md[3];
  
    vparse($HTML::TEMP);
  }
  close(DATA);

  print $HTML::FOOT;
}

sub fsplit {
  my($file) = shift;
  open(FILE, "$file") || err($!, $file);
  my @data = split(/\|/, <FILE>);
  close(FILE);

  return \@data;
}

sub getmem {
  my $id = shift;
  $id =~ s/\..+$//;
  return $id;
}

sub urlencode {
  my $url = shift;
  $url =~ s/([^\w\.\-])/sprintf("%s%x", '%', ord($1))/eg;
  return $url;
}

sub dread {
  my($dir, $patt) = @_;
  opendir(DIR, $dir) || err($!, $dir);
  my @files = grep { /$patt/ } sort readdir(DIR);
  closedir(DIR);

  return \@files;
}

sub vparse {
  my($html, $fh) = @_;
  $fh = *STDOUT if(!$fh);
  $html =~ s/#%(.*?)%#/$TPL{$1}/gise;
  print $fh $html;
}

sub err {
  my($cause, $file) = @_;
  my @from = caller(1);
  chomp($cause);

  print "<pre>\n";
  print "A CGI ERROR HAS OCCURRED\n========================\n";
  print "Error Message     :  $cause\n";   
  print "Accessing File    :  $file\n";
  print "Calling Function  :  $from[3] from $from[1]" if( $from[3] ne "" );
  exit;
}