#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.0  ##
##################################################
##  init.cgi - initialize if using .htaccess    ##
##################################################

package init;

use lib '.';                                    ## You may need to change this to the full path to cgiworks.pm
use strict;
use cgiworks;
use vars qw( $ADIR );

$ADIR = './admin';                              ## You may need to change this to the full path to the admin directory

print "Content-type: text/html\n\n";
$HEADER = 1;

eval {
  require 'arp.pl';
  main();
};

err("$@", 'init.cgi') if( $@ );
exit;

#####################################################################
##  Removing the link back to CGI Works is a copyright violation.  ##
##  Altering or removing any of the code that is responsible, in   ##
##  any way, for generating that link is strictly forbidden.       ##
##  Anyone violating the above policy will have their license      ##
##  terminated on the spot.  Do not remove that link - ever.       ##
#####################################################################

sub main {
  return if( !$ENV{'REQUEST_METHOD'} );
  fwritenew("$ADIR/.htpasswd", 'admin:' . crypt('admin', getsalt()) . "\n");

  print <<HTML;
<html>
<head>
  <title>AutoRank Pro Initialization</title>
</head>
<body bgcolor="#ffffff" text="#000000" link="#7384BD" vlink="#adadad" alink="#ff0000">

<div align="center">

<table border="0" cellpadding="0" cellspacing="0" width="650">
<tr bgcolor="#000000">
<td align="center">

<table cellspacing="1" cellpadding="3" border="0" width="100%">
<tr>
<td bgcolor="#7384BD" align="center">
<font face="Arial" size="3" color="white">
<b>AutoRank Pro Initialization</b>
</font>
</td>
</tr>

<tr>
<td bgcolor="#ffffff">
<font face="Arial" size="2">
AutoRank Pro has been intialized.  You should now visit the <a href="admin/setup.cgi">setup.cgi</a> script so you can 
enter your variables and options.

<br><br>

Default login information has been set for the administrative area.  Use the following for your initial access:

<br><br>

<b>Username:</b> admin<br>
<b>Password:</b> admin

<br><br>

<b>If the username and password are not accepted</b>

<br><br>

This indicates that the .htaccess file in the admin directory has not been properly configured.  Double check that you
have entered the correct path to the .htpasswd file.  If you are absolutely sure you have, you will need to contact your
server administrator for assistance with .htaccess on your server.

<br><br>

<b>If you receive a 500 Server Error</b>

<br><br>

If you get a 500 Server Error before you are able to enter your login information, it indicates there is a problem with your
.htaccess file.  Double check to see that it has been setup properly, or contact your server administrator to find out the
proper usage of .htaccess on your server.

<br><br>

If you get the error after you enter your login information, there are a few things to check.  First off, try changing the 
permissions on the admin directory to 755.  If that does not help, double check that you have setup a valid perl path, that
all permissions are set properly, and that you have uploaded all files in ASCII mode.
</font>
</td>
</tr>

</table>

</td>
</tr>
</table>

</body>
</html>
HTML
}
