#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
##################################################
##  random.cgi - send surfers to a random link  ##
##################################################

package rnd;

use strict;
#push(@INC, 'c:/full/path/to/cgi/scripts');       ## NT support - uncomment and fill in correct path if necessary.

my $DDIR = './data';

eval {
  require "$DDIR/vars.dat";
  main();
};

err("$@", 'random.cgi') if( $@ );
exit;

#####################################################################
##  Removing the link back to CGI Works is a copyright violation.  ##
##  Altering or removing any of the code that is responsible, in   ##
##  any way, for generating that link is strictly forbidden.       ##
##  Anyone violating the above policy will have their license      ##
##  terminated on the spot.  Do not remove that link - ever.       ##
#####################################################################

sub main {
  my $sites = freadall("$DDIR/dbs/sites");
  my $site  = $sites->[int( rand($#{ $sites } + 1) )];
  if( $site eq '' ) {
    print "Location: $VAR::FU\n\n";
    return;
  }
  my $md    = fsplit("$DDIR/members/$site.dat");

  if( $OPT::OUT && -e "$DDIR/members/$site.cnt" ) {
    open(MEM, "+<$DDIR/members/$site.cnt") || err($!, "$DDIR/members/$site.cnt");
    flock(MEM, 1);
    my @cd = split(/\|/, <MEM>);
    flock(MEM, 8);

    $cd[1]++;
    $cd[3]++;

    flock(MEM, 2);
    truncate(MEM, 0);
    seek(MEM, 0, 0);
    print MEM join('|', @cd);
    flock(MEM, 8);
    close(MEM);
  }

  print "Location: $md->[1]\n\n";
}

sub freadall {
  my($file) = shift;
  open(FILE, $file) || err($!, $file);
  flock(FILE, 1);
  my @lines = <FILE>;
  close(FILE);
  chomp(@lines);

  return \@lines;
}

sub fsplit {
  my($file) = shift;
  open(FILE, "$file") || err($!, $file);
  flock(FILE, 1);
  my @data = split(/\|/, <FILE>);
  close(FILE);

  return \@data;
}

sub getmem {
  my $id = shift;
  $id =~ s/\..+$//;
  return $id;
}

sub urlencode {
  my $url = shift;
  $url =~ s/([^\w\.\-])/sprintf("%s%x", '%', ord($1))/eg;
  return $url;
}

sub err {
  my($cause, $file) = @_;
  my @from = caller(1);
  chomp($cause);

  print "Content-type: text/html\n\n";
  print "<pre>\n";
  print "A CGI ERROR HAS OCCURRED\n========================\n";
  print "Error Message     :  $cause\n";   
  print "Accessing File    :  $file\n";
  print "Calling Function  :  $from[3] from $from[1]" if( $from[3] ne "" );
  exit;
}