#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
######################################################
##  upgrade.cgi - upgrade from AutoRank Pro v2.1.x  ##
######################################################

package upg;

use lib '.';                                    ##  You may need to change this to the full path to cgiworks.pm
use strict;
use cgiworks;
use SDBM_File;

print "Content-type: text/html\n\n";
$HEADER = 1;

eval {
  require 'functions.cgi';
  err('AutoRank Pro v2.1.x Installation Not Found', 'upgradearp.cgi') if( $fnct::ver ne '2.1.1' && $fnct::ver ne '2.1.0' );

  dcreate("$DDIR/html", 0777);
  dcreate("$DDIR/breaks", 0777);
  dcreate("$DDIR/icons", 0777);
  dcreate("$DDIR/members", 0777);
  dcreate("$DDIR/dbs", 0777);

  main();
};

err("$@", 'upgradearp.cgi') if( $@ );
exit;

sub main {
  print "<pre>";
  print "AutoRank Pro v$fnct::ver Installation Located...importing data\n\n";
  members();
  bans();
  icons();
  breaks();
  html();
  vars();
  print "\nYour data has been successfully imported, and you\n";
  print "can continue on to the next step of the upgrade.";
}

sub members {
  my $num = 0;
  my %mem;

  dbmopen(%mem, "$fnct::sd_dir/members", 0666) || err($!, 'members');
  for( keys %mem ) {
    my @md = split(/\|/, $mem{$_});

    $md[13] = $md[13] eq '0' ? 1 : 0;
    $md[14] = $md[14] eq '0' ? 1 : 0;
    $md[15] = '' if( $md[15] eq 'none' );

    fjoin("$DDIR/members/$_.dat", $md[10], $md[8], $md[9], $VAR::BH, $VAR::BW, '', $md[5], $md[6], $md[7], $md[15], time, '1:1', '1.000', 'N/A', 'N/A', 'N/A', 'N/A', 'N/A', crypt(unpack('u', $md[12]), getsalt()), $md[12], $md[13], $md[14], $md[2], '', '', '');
    fjoin("$DDIR/members/$_.cnt",  0, 0, 0, 0, '1:1', '1.000', $md[7], $md[13], time);
    fwrite("$DDIR/members/$_.sts", '');
    fappend("$DDIR/dbs/sites", "$_\n");
    fappend("$DDIR/dbs/search", "$_|$md[5]|$md[7]|$md[8]|$md[6]\n");
    $num++;
  }
  dbmclose(%mem);

  print "$num Members Imported\n";
}

sub bans {
  my $num = 0;
  my %bans;
 
  dbmopen(%bans, "$fnct::sd_dir/bans", 0666) || err($!, 'bans');
  for( keys %bans ) {
    fappend("$DDIR/dbs/word.ban", "$bans{$_}\n") if( $_ =~ /^word_/ );
    fappend("$DDIR/dbs/email.ban", "$bans{$_}\n") if( $_ =~ /^email_/ );
    fappend("$DDIR/dbs/url.ban", "$bans{$_}\n") if( $_ =~ /^url_/ );
    $num++;
  }
  dbmclose(%bans);

  print "$num Bans Imported\n";
}

sub icons {
  my $num = 0;
  my %data;
 
  dbmopen(%data, "$fnct::sd_dir/info", 0666) || err($!, 'info');
  for( keys %data ) {
    if( $_ =~ /^icon_(.*)/ ) {
      my $icon = $1;
      fwrite("$DDIR/icons/$icon", qq|<img src="$data{$_}">|);
      $num++;
    }
  }
  dbmclose(%data);

  print "$num Icons Imported\n";
}

sub breaks {
  my $num = 0;
  my %data;
  my $mrp = (split(/,/, $VAR::PL))[0];
 
  dbmopen(%data, "$fnct::sd_dir/info", 0666) || err($!, 'info');
  for( split(/,/, $VAR::BA) ) {
    fwrite("$DDIR/breaks/$_.$mrp", $data{$_});
    $num++;
  }
  dbmclose(%data);

  print "$num List Breaks Imported\n";
}

sub html {
  my $mrp = (split(/,/, $VAR::PL))[0];
  require "$fnct::sd_dir/$mrp";

  $HTML::HEADER =~ s/#%UPDATE%#/#%LUPDT%#/g;
  $HTML::HEADER =~ s/#%NEXTUP%#/#%NUPDT%#/g;
  $HTML::HEADER =~ s/#%TOTAL%#/#%TOT%#/g;
  $HTML::HEADER =~ s/#%TITLE%#/#%SOMTITLE%#/g;
  $HTML::HEADER =~ s/#%DESC%#/#%SOMDESC%#/g;
  $HTML::HEADER =~ s/#%BANNER%#/#%SOMBAN%#/g;
  $HTML::HEADER =~ s/#%URL%#/#%SOMURL%#/g;
  $HTML::HEADER =~ s/#%ICONS%#/#%SOMICONS%#/g;

  $HTML::FOOTER =~ s/#%UPDATE%#/#%LUPDT%#/g;
  $HTML::FOOTER =~ s/#%NEXTUP%#/#%NUPDT%#/g;
  $HTML::FOOTER =~ s/#%TOTAL%#/#%TOT%#/g;
  $HTML::FOOTER =~ s/#%TITLE%#/#%SOMTITLE%#/g;
  $HTML::FOOTER =~ s/#%DESC%#/#%SOMDESC%#/g;
  $HTML::FOOTER =~ s/#%BANNER%#/#%SOMBAN%#/g;
  $HTML::FOOTER =~ s/#%URL%#/#%SOMURL%#/g;
  $HTML::FOOTER =~ s/#%ICONS%#/#%SOMICONS%#/g;

  $HTML::TMPL =~ s/#%RANK%#/#%ORANK%#/g;
  $HTML::TMPL =~ s/#%FONT_SIZE%#/#%FSIZE%#/g;
  $HTML::TMPL =~ s/#%PREVRANK%#/#%PORANK%#/g;
  $HTML::TMPL =~ s/#%PREVIN%#/#%PIN%#/g;

  fwrite("$DDIR/html/$mrp", qq|\$HTML::HEAD = <<'HD';\n$HTML::HEADER\nHD\n\n\$HTML::FOOT = <<'FT';\n$HTML::FOOTER\nFT\n\n\$HTML::TEMP = <<'TP';\n$HTML::TMPL\nTP\n\n1;\n|);
  print "Main Ranking Page HTML Imported\n";
}

sub vars {
  my $mrp = (split(/,/, $VAR::PL))[0];

  open(VARS, ">$DDIR/vars.dat") || err($!, 'vars.dat');

  print VARS "\$VAR::BO = '$VAR::BA';\n";
  print VARS "\$VAR::BH = '$VAR::BH';\n";
  print VARS "\$VAR::BW = '$VAR::BW';\n";
  print VARS "\$VAR::CT = '$VAR::CT';\n";
  print VARS "\$VAR::CU = '$VAR::CU';\n";
  print VARS "\$VAR::IU = '$VAR::CU/rankem.cgi';\n";
  print VARS "\$VAR::OU = '$VAR::CU/out.cgi';\n";
  print VARS "\$VAR::EM = '$VAR::EM';\n";
  print VARS "\$VAR::ES = '$VAR::ES';\n";
  print VARS "\$VAR::FO = '$VAR::FS';\n";
  print VARS "\$VAR::FU = '$VAR::FU';\n";
  print VARS "\$VAR::HD = '$VAR::HD';\n";
  print VARS "\$VAR::HU = '$VAR::HU';\n";
  print VARS "\$VAR::MD = '$VAR::MD';\n";
  print VARS "\$VAR::MH = '$VAR::MH';\n";
  print VARS "\$VAR::MT = '$VAR::MT';\n";
  print VARS qq|\$VAR::NI = '<img src="$VAR::NI" alt="New">';\n|;
  print VARS "\$VAR::NS = '$VAR::NS';\n";
  print VARS "\$VAR::RP = '$mrp';\n";
  print VARS "\$VAR::RR = '$VAR::RR';\n";
  print VARS "\$VAR::RS = '$VAR::RS';\n";
  print VARS "\$VAR::SO = '$VAR::SA';\n";
  print VARS "\$VAR::OL = '$VAR::SL';\n";
  print VARS "\$VAR::TZ = '$VAR::TZ';\n";
  print VARS "\$VAR::OB = '$VAR::BN';\n";
  print VARS "\$OPT::GAT = '$OPT::DBL';\n" if($OPT::DBL);
  print VARS "\$OPT::EML = '$OPT::EML';\n" if($OPT::EML);
  print VARS "\$OPT::NEW = '$OPT::NEW';\n" if($OPT::NEW);
  print VARS "\$OPT::OUT = '$OPT::OUT';\n" if($OPT::OUT);
  print VARS "\$OPT::REV = '$OPT::REV';\n" if($OPT::REV);
  print VARS "\$OPT::CRN = '$OPT::CRN';\n" if($OPT::CRN);

  print VARS "1;\n";
  close(VARS);
  mode(0666, "$DDIR/vars.dat");
  print "Selected Variables Imported\n";
}